﻿"use strict";

var CurrentContainer;

jQuery(function ($) {
  $.datepicker.regional['de'] = { clearText: 'löschen', clearStatus: 'aktuelles Datum löschen',
    closeText: 'schließen', closeStatus: 'ohne Änderungen schließen',
    prevText: '<zurück', prevStatus: 'letzten Monat zeigen',
    nextText: 'Vor>', nextStatus: 'nächsten Monat zeigen',
    currentText: 'heute', currentStatus: '',
    monthNames: ['Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember'],
    monthNamesShort: ['Jan', 'Feb', 'Mär', 'Apr', 'Mai', 'Jun', 'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez'],
    monthStatus: 'anderen Monat anzeigen', yearStatus: 'anderes Jahr anzeigen',
    weekHeader: 'Wo', weekStatus: 'Woche des Monats',
    dayNames: ['Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'],
    dayNamesShort: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
    dayNamesMin: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
    dayStatus: 'Setze DD als ersten Wochentag', dateStatus: 'Wähle D, M d',
    dateFormat: 'dd.mm.yy', firstDay: 1,
    initStatus: 'Wähle ein Datum', isRTL: false
  };
  $.datepicker.setDefaults($.datepicker.regional['de']);
});

(function ($) {
  $.fn.moveTo = function (selector) {
    return this.each(function () {
      var cl = $(this).clone();
      $(cl).appendTo(selector);
      $(this).remove();
    });
  };
})(jQuery);

function CheckFlag(Flags, Flag) {
  return ((Flags & Flag) == Flag);
}

/* --------------------------------------------------------- */

// AddGadgetColumn(#Gadget, Position, Title$, Width)
function AddGadgetColumn(Gadget, Position, Title, Width) {

  switch (GadgetType(Gadget)) {

    case PBW_GadgetType_ListIcon:

      var c = w2ui["g_" + Gadget].columns;

      if (Position > c.length) {
        Position = c.length;
      }

      if (Position == c.length) {
        w2ui["g_" + Gadget].addColumn({ field: guid(), caption: Title, size: Width });
      }
      else {
        var s = c[Position - 1].field;
        w2ui["g_" + Gadget].addColumn(s, { field: guid(), caption: Title, size: Width });
      }

      break;

    case PB_GadgetType_ListIcon:

      var listIconGadget = $("#g_" + Gadget).find("table");

      var c = $("#g_" + Gadget + " th").length;

      if (Position > c) {
        Position = c;
      }

      if (Position == c) {
        listIconGadget.find("thead").find("tr").append("<th style='color:white;width:" + Width + "px; height:1%'>" + Title + "</th>");
      }
      else {
        $("<th style='color:white';>" + Title + "</th>").insertBefore($("#g_" + Gadget + " th:eq(" + Position + ")"));
      }

      break;

  }

}


/* --------------------------------------------------------- */

// Result = AddGadgetItem(#Gadget, Position, Text$ [, ImageID [, Flags]])
function AddGadgetItem(Gadget, Position, Text, ImageID, Flags) {

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_Panel:

      var id = guid();

      if (Position > $("#g_" + Gadget + " li").size()) {
        Position = $("#g_" + Gadget + " li").size();
      }

      var li = $("<li><a href='#pi_" + id + "'>" + Text + "</a></li>");

      if (Position == -1 || Position == $("#g_" + Gadget + " li").size()) {
        $("#g_" + Gadget).find(".ui-tabs-nav").append(li);
      }
      else {
        li.insertBefore("#g_" + Gadget + " li:eq(" + Position + ")");
      }

      $("#g_" + Gadget).append("<div id='pi_" + id + "'></div>");
      $("#g_" + Gadget).tabs("refresh");

      CurrentContainer = $("#pi_" + id);

      $("#g_" + Gadget).tabs('option', 'active', 0);

      break;

    case PBW_GadgetType_ListIcon:

      var listIconGadget = w2ui["g_" + Gadget]

      var recId = listIconGadget.records.length;

      listIconGadget.add({ recid: recId });

      var hu = listIconGadget.records[recId];

      var Splitter = Text.split(Chr(10));
      $.each(Splitter, function (i, Split) {
        var fieldname = listIconGadget.columns[i].field;
        listIconGadget.records[recId][fieldname] = Split;
      });

      break;

    case PB_GadgetType_ListIcon:

      var CurrentLine;

      if (Position > -1) {
        $("<tr></tr>").insertBefore("#g_" + Gadget + " table tbody tr:eq(" + Position + ")");
        CurrentLine = $("#g_" + Gadget + " tbody tr:eq(" + Position + ")");
      }
      else {
        $("#g_" + Gadget + " table tbody").append("<tr></tr>");
        CurrentLine = $("#g_" + Gadget + " tbody tr:last")
      }

      var Splitter = Text.split(Chr(10));
      $.each(Splitter, function (i, Split) {
        CurrentLine.append("<td style='height:1%'>" + Split + "</td>");
      });

      break;

    case PB_GadgetType_ComboBox: case PB_GadgetType_ListView:

      if ((Position == -1) || ($("#g_" + Gadget + " option").size() == 0)) {
        $("#g_" + Gadget).append("<option>" + Text + "</option>");
      }

      else {

        if (Position > $("#g_" + Gadget + " option").size() - 1) {
          Position = $("#g_" + Gadget + " option").size() - 1;
        }

        if (Position == $("#g_" + Gadget + " option").size() - 1) {
          $("#g_" + Gadget).append("<option>" + Text + "</option>");
        }
        else {
          $("<option>" + Text + "</option>").insertBefore("#g_" + Gadget + " option:eq(" + Position + ")");
        }


      }

      break;
  }

}

/* --------------------------------------------------------- */

// RemoveGadgetItem(#Gadget, Position)
function RemoveGadgetItem(Gadget, Position) {

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_Panel:

      var id = $("#g_" + Gadget + " li:eq(" + Position + ") a").attr("href");

      $("#g_" + Gadget + " li:eq(" + Position + ")").remove();

      $(id).remove();

      $("#" + Gadget).tabs("refresh");

      break;

    case PB_GadgetType_ListView:
      $("#g_" + Gadget + " option:eq(" + Position + ")").remove();
      break;

    case PBW_GadgetType_ListView:
      //$("#g_" + Gadget + " option:eq(" + Position + ")").remove();
      break;

    default:
      console.log('RemoveGadgetItem(): Not implemented for this type of gadget (yet)');
      break;

  }

}

/* --------------------------------------------------------- */

// Result = ButtonGadget(#Gadget, x, y, Width, Height, Text$ [, Flags])
function ButtonGadget(Gadget, x, y, Width, Height, Text, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  if (Flags) {
    if (CheckFlag(Flags, PB_Button_Toggle)) {
      console.log('PB_Button_Toggle-Flag: Not implemented (yet)');
    }
  }

  var buttonGadget = $("<button />").button({ label: Text });

  buttonGadget.attr("id", "g_" + Gadget);
  buttonGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });
  buttonGadget.data("GadgetType", PB_GadgetType_Button);

  CurrentContainer.append(buttonGadget);

  return Gadget;

}

/* --------------------------------------------------------- */

function ButtonGadget_WF(Gadget, x, y, Width, Height, Text, Flags) {
  var buttonGadget = $.PureBasic.ButtonGadget({ gadgetid: Gadget, text: Text, x: x, y: y, width: Width, height: Height });
  return buttonGadget.gadgetid;
}

/* --------------------------------------------------------- */

// Result = ButtonImageGadget(#Gadget, x, y, Width, Height, ImageID [, Flags])
function ButtonImageGadget(Gadget, x, y, Width, Height, ImageID, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  if (Flags) {
    if (CheckFlag(Flags, PB_Button_Toggle)) {
      console.log('PB_Button_Toggle-Flag: Not implemented (yet)');
    }
  }

  var buttonImageGadget = $("<button />").button();

  buttonImageGadget.attr("id", "g_" + Gadget);
  buttonImageGadget.attr("type", inputType);
  buttonImageGadget.css({ "background-image": "url(" + $("#i_" + ImageID).attr("src") + ")" });
  buttonImageGadget.css({ "background-repeat": "no-repeat" });
  buttonImageGadget.css({ "border": "none" });
  buttonImageGadget.css({ "font-size": "0px" });
  buttonImageGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });
  buttonImageGadget.data("GadgetType", PB_GadgetType_ButtonImage);

  CurrentContainer.append(buttonImageGadget);

  return Gadget;

}

/* --------------------------------------------------------- */

function CalendarGadget() {
  console.log('CalendarGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function CanvasGadget() {
  console.log('CanvasGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function CanvasOutput() {
  console.log('CanvasOutput(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// Result = CheckBoxGadget(#Gadget, x, y, Width, Height, Text$ [, Flags])
function CheckBoxGadget(Gadget, x, y, Width, Height, Text, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  CurrentContainer.append("<div id='g_" + Gadget + "'><input type='checkbox' id='cb_" + Gadget + "' /><label id='lbl_" + Gadget + "' for='cb_" + Gadget + "'>" + Text + "</label><div>");

  $("#g_" + Gadget).css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  //  #PB_CheckBox_Right     : Aligns the text to right.
  //  #PB_CheckBox_Center    : Centers the text.
  //  #PB_CheckBox_ThreeState: Create a checkbox that can have a third "in between" state.


  $("#g_" + Gadget).data("GadgetType", PB_GadgetType_CheckBox);

  return Gadget;

}

/* --------------------------------------------------------- */

// ClearGadgetItems(#Gadget)
function ClearGadgetItems(Gadget) {

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_Panel:
      $("#g_" + Gadget).find("li").remove();
      $("#g_" + Gadget).find("div").remove();
      break;

    case PB_GadgetType_ListIcon:
      $("#g_" + Gadget).find("tbody").empty();
      break;

    case PB_GadgetType_ListView:
      $("#g_" + Gadget).empty();
      break;

  }

}

/* --------------------------------------------------------- */

function CloseGadgetList() {

  if (CurrentContainer.parent == null) { return; }

  CurrentContainer = CurrentContainer.parent();

}

/* --------------------------------------------------------- */

// Result = ComboBoxGadget(#Gadget, x, y, Width, Height [, Flags])
function ComboBoxGadget(Gadget, x, y, Width, Height, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var comboBoxGadget = $("<select />");

  comboBoxGadget.attr("id", "g_" + Gadget);
  comboBoxGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height, "overflow": "auto" });

  // #PB_ComboBox_Editable  : Makes the ComboBox editable
  // #PB_ComboBox_LowerCase : All text entered in the ComboBox will be converted to lower case.
  // #PB_ComboBox_UpperCase : All text entered in the ComboBox will be converted to upper case.
  // #PB_ComboBox_Image     : Enable support for images in items (not supported for editable ComboBox on OSX)

  comboBoxGadget.data("GadgetType", PB_GadgetType_ComboBox);

  CurrentContainer.append(comboBoxGadget);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = ContainerGadget(#Gadget, x, y, Width, Height [, Flags])
function ContainerGadget(Gadget, x, y, Width, Height, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var containerGadget = $("<div />");

  containerGadget.attr("id", "g_" + Gadget);

  containerGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height, "overflow": "auto" });

  /*
  #PB_Container_BorderLess : Without any border (Default).
  #PB_Container_Flat       : Flat frame.
  #PB_Container_Raised     : Raised frame.
  #PB_Container_Single     : Single sunken frame.
  #PB_Container_Double     : Double sunken frame.
  */

  if (Flags) {
    if (Flags != PB_Container_BorderLess) {
      containerGadget.css({ "border": "1px solid black" });
    }
  }

  containerGadget.data("GadgetType", PB_GadgetType_Container);

  CurrentContainer.append(containerGadget);

  CurrentContainer = $("#g_" + Gadget);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = ContainerGadget(#Gadget, x, y, Width, Height [, Flags])
function ContainerGadget2(Gadget, x, y, Width, Height, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var containerGadget = $("<div />");

  containerGadget.attr("id", "g_" + Gadget);

  containerGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height});

  /*
  #PB_Container_BorderLess : Without any border (Default).
  #PB_Container_Flat       : Flat frame.
  #PB_Container_Raised     : Raised frame.
  #PB_Container_Single     : Single sunken frame.
  #PB_Container_Double     : Double sunken frame.
  */

  if (Flags) {
    if (Flags != PB_Container_BorderLess) {
      containerGadget.css({ "border": "1px solid black" });
    }
  }

  containerGadget.data("GadgetType", PB_GadgetType_Container);

  CurrentContainer.append(containerGadget);

  CurrentContainer = $("#g_" + Gadget);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = CountGadgetItems(#Gadget)
function CountGadgetItems(Gadget) {

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_Panel:
      return $("#g_" + Gadget).find("li").size();
      break;

    case PB_GadgetType_ListIcon:
      return $("#g_" + Gadget).find("tbody tr").size();
      break;

    case PB_GadgetType_ListView:
      return $("#g_" + Gadget + " option").size();
      break;

  }

}

/* --------------------------------------------------------- */

// Result = DateGadget(#Gadget, x, y, Width, Height [, Mask$ [, Date [, Flags]]])
function DateGadget(Gadget, x, y, Width, Height, Mask, Date, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var dateGadget = $("<input type='text' />")

  dateGadget.attr("id", "g_" + Gadget);

  dateGadget.datepicker();

  dateGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height, "overflow": "auto" });

  dateGadget.data("GadgetType", PB_GadgetType_Date);

  /*

  todo:

  #PB_Gadget_BackColor      : backgroundcolor
  #PB_Gadget_FrontColor     : textcolor for displayed days
  #PB_Gadget_TitleBackColor : backgroundcolor of the month title
  #PB_Gadget_TitleFrontColor: textcolor of the month title
  #PB_Gadget_GrayTextColor  : textcolor for days not of the current month

  */

  CurrentContainer.append(dateGadget);

  return Gadget;

}

/* --------------------------------------------------------- */

// DisableGadget(#Gadget, State)
function DisableGadget(Gadget, State) {

  // The new state of the gadget. If State = 1, the gadget will be disabled, if State = 0 it will be enabled.

  if (State == true) {
    $("#g_" + Gadget).attr('disabled', 'disabled');
    $("#g_" + Gadget).addClass("ui-state-disabled");

  }
  else {
    $("#g_" + Gadget).removeAttr('disabled');
    $("#g_" + Gadget).removeClass("ui-state-disabled");
  }

}

/* --------------------------------------------------------- */

function EditorGadget() {
  console.log('EditorGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function ExplorerComboGadget() {
  console.log('ExplorerComboGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function ExplorerListGadget() {
  console.log('ExplorerListGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function ExplorerTreeGadget() {
  console.log('ExplorerTreeGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function Frame3DGadget() {
  console.log('Frame3DGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// FreeGadget(#Gadget)
function FreeGadget(Gadget) {

  if ($("#g_" + Gadget) == null) { return; }

  $("#g_" + Gadget).empty();
  $("#g_" + Gadget).remove();

}

/* --------------------------------------------------------- */

// Result = GadgetWidth(#Gadget)
function GadgetWidth(Gadget) {
  return $("#g_" + Gadget).width();
}

/* --------------------------------------------------------- */

// Result = GadgetHeight(#Gadget)
function GadgetHeight(Gadget) {
  return $("#g_" + Gadget).height();
}

/* --------------------------------------------------------- */

function GadgetID() {
  console.log('GadgetID(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function GadgetItemID() {
  console.log('GadgetItemID(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// GadgetToolTip(#Gadget, Text$)
function GadgetToolTip(Gadget, Text) {
  $("#g_" + Gadget).attr("title", Text);
}

/* --------------------------------------------------------- */

// Result = GadgetType(#Gadget)
function GadgetType(Gadget) {
  return $("#g_" + Gadget).data("GadgetType");
}

/* --------------------------------------------------------- */

// Result = GadgetX(#Gadget [, Mode])
function GadgetX(Gadget, Mode) {

  /*

  ToDo:

  #PB_Gadget_ContainerCoordinate: the gadget X position (in pixels) within its container, or window (default)
  #PB_Gadget_WindowCoordinate   : the absolute gadget X position (in pixels) within the window.
  #PB_Gadget_ScreenCoordinate   : the absolute gadget X position (in pixels) in the screen.
  It can be useful to display something over the gadget like a floating window or a popup menu.

  */

  return $("#g_" + Gadget).css("left");

}

/* --------------------------------------------------------- */

// Result = GadgetY(#Gadget [, Mode])
function GadgetY(Gadget, Mode) {

  /*

  ToDo:

  #PB_Gadget_ContainerCoordinate: the gadget Y position (in pixels) within its container, or window (default)
  #PB_Gadget_WindowCoordinate   : the absolute gadget Y position (in pixels) within the window.
  #PB_Gadget_ScreenCoordinate   : the absolute gadget Y position (in pixels) in the screen.
  It can be useful to display something over the gadget like a floating window or a popup menu.

  */

  return $("#g_" + Gadget).css("top");

}

/* --------------------------------------------------------- */

// Result = GetActiveGadget()
function GetActiveGadget() {
  // not supported (yet)
  return -1;
}

/* --------------------------------------------------------- */

// HideGadget(#Gadget, State)
function HideGadget(Gadget, State) {
  if (State == true) {
    $("#g_" + Gadget).hide();
  }
  else {
    $("#g_" + Gadget).show();
  }
}

/* --------------------------------------------------------- */

// Result = HyperLinkGadget(#Gadget, x, y, Width, Height, Text$, Color [, Flags])
function HyperLinkGadget(Gadget, x, y, Width, Height, Text, Url, Color, Flags) {
  console.log('HyperLinkGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function IPAddressGadget() {
  console.log('IPAddressGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// Result = ImageGadget(#Gadget, x, y, Width, Height, ImageID [, Flags])
function ImageGadget(Gadget, x, y, Width, Height, ImageID, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  CurrentContainer.append("<img id='g_" + Gadget + "' />");

  $("#g_" + Gadget).attr("src", $("#i_" + ImageID).attr("src"));

  // if (Height == -1) {
  //  $("#g_" + Gadget).css({ "height": $("#i_" + ImageID).height() });
  // }
  // else {
  $("#g_" + Gadget).css({ "height": Height });
  // }

  // if (Width == -1) {
  //   $("#g_" + Gadget).css({ "width": $("#i_" + ImageID).width() });
  // }
  // else {
  $("#g_" + Gadget).css({ "width": Width });
  // }

  $("#g_" + Gadget).css({ "position": "absolute", "top": y, "left": x });

  $("#g_" + Gadget).data("GadgetType", PB_GadgetType_Image);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = IsGadget(#Gadget)
function IsGadget(Gadget) {
  console.log('IsGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// Result = ListIconGadget(#Gadget, x, y, Width, Height, Title$, TitleWidth [, Flags])
function ListIconGadget(Gadget, x, y, Width, Height, Title, TitleWidth, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var listIconGadget = $("<div><table><thead><tr bgcolor='rgb(0, 112, 192)'></tr></thead><tbody></tbody></table><div>");

  listIconGadget.attr("id", "g_" + Gadget);

  // events to de-/select rows

  listIconGadget.delegate(" tbody tr ", 'click', function () {

    $("#g_" + Gadget + " > table > tbody  > tr").each(function () {

      if ($(this).data("selected") == true) {
        $(this).data("selected", false);
        $(this).css({ "background-color": "white", "color": "black" });
      }

    });


    $(this).data("selected", true);
    $(this).css({ "background-color": "blue", "color": "white" });

  });

  listIconGadget.find("table").css({ "width": "100%", "height": "100%" });

  listIconGadget.find("table").attr("border", "1");

  // listIconGadget.find("table").css({ "border": "1px solid black" });

  listIconGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });
  listIconGadget.css({ "overflow": "auto", "border": "1px solid black" });

  listIconGadget.data("GadgetType", PB_GadgetType_ListIcon);

  CurrentContainer.append(listIconGadget);

  AddGadgetColumn(Gadget, 0, Title, TitleWidth);

  return Gadget;

}


// Result = ListIconGadget(#Gadget, x, y, Width, Height, Title$, TitleWidth [, Flags])
function ListIconGadget_ST(Gadget, x, y, Width, Height, Title, TitleWidth, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var listIconGadget = $("<table cellpadding='0' cellspacing='0'></table>");

  listIconGadget.attr("id", "g_" + Gadget);

  listIconGadget.selecTable({

    columns: [ //Define columns with a name attribute and a value function.
            {
            name: "Title",
            value: function (record) {
              if (record.title) { return record.title; }
              else { return "-None-"; }
            }
          },
            {
              name: "Author",
              value: function (record) {
                if (record.author) { return record.author; }
                else { return "Anonymous"; }
              }
            },
            {
              name: "Copyright",
              value: function (record) {
                if (record.copyright) { return record.copyright; }
                else { return "Unknown"; }
              }
            }
        ]
  });

  var ccc = listIconGadget.selecTable;

  listIconGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  listIconGadget.data("GadgetType", PB_GadgetType_ListIcon);

  CurrentContainer.append(listIconGadget);

  AddGadgetColumn(Gadget, 0, Title, TitleWidth);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = ListViewGadget(#Gadget, x, y, Width, Height [, Flags])
function ListViewGadget(Gadget, x, y, Width, Height, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  Height += 5;

  CurrentContainer.append("<select id='g_" + Gadget + "' size='2'></select>");

  $("#g_" + Gadget).css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  $("#g_" + Gadget).data("GadgetType", PB_GadgetType_ListView);

  return Gadget;

}

/* --------------------------------------------------------- */

function MDIGadget() {
  console.log('MDIGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function OpenGadgetList() {
  console.log('OpenGadgetList(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function OptionGadget() {
  console.log('OptionGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// Result = PanelGadget(#Gadget, x, y, Width, Height)
function PanelGadget(Gadget, x, y, Width, Height) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var panelGadget = $("<div><ul /></div>");

  panelGadget.attr("id", "g_" + Gadget);

  panelGadget.tabs();

  CurrentContainer.append(panelGadget);

  panelGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  panelGadget.data("GadgetType", PB_GadgetType_Panel);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = PanelGadget(#Gadget, x, y, Width, Height)
function PanelGadget_PBW(Gadget, x, y, Width, Height) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var panelGadget = $("<div></div>");

  panelGadget.attr("id", "g_" + Gadget);

  panelGadget.w2tabs({
    name: 'tabs',
    active: 'tab1',
    tabs: [
		{ id: 'tab1', caption: 'Tab 1' },
		{ id: 'tab2', caption: 'Tab 2' },
		{ id: 'tab3', caption: 'Tab 3' },
		{ id: 'tab4', caption: 'Tab 4' }
	  ]
  });

  CurrentContainer.append(panelGadget);

  panelGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  panelGadget.data("GadgetType", PBW_GadgetType_Panel);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = ProgressBarGadget(#Gadget, x, y, Width, Height, Minimum, Maximum [, Flags])
function ProgressBarGadget(Gadget, x, y, Width, Height, Minimum, Maximum, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var progressBarGadget = $("<div />").progressbar({

    value: 50,
    max: Maximum

  });

  progressBarGadget.attr("id", "g_" + Gadget);

  CurrentContainer.append(progressBarGadget);

  progressBarGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  // #PB_ProgressBar_Smooth   
  // #PB_ProgressBar_Vertical 

  progressBarGadget.data("GadgetType", PB_GadgetType_ProgressBar);

  progressBarGadget.data("pbmin", Minimum);
  progressBarGadget.data("pbmax", Maximum);

  return Gadget;

}

/* --------------------------------------------------------- */

// RemoveGadgetColumn(#Gadget, Column)
function RemoveGadgetColumn(Gadget, Column) {

  switch (GadgetType(Gadget)) {

    case PB_GadgetType_ListIcon:

      $("#g_" + Gadget + " thead tr th:eq(" + Column + ")").remove();

      $("#g_" + Gadget + " tbody tr").each(function () {
        $(this).find("td:eq(" + Column + ")").remove();
      });

      break;

    case PB_GadgetType_Explorer:
      console.log('RemoveGadgetColumn(): Not implemented for this type of gadget (yet)');
      break;

    default:
      console.log('RemoveGadgetColumn(): Not supported for this type of gadget');
      break;

  }

}

/* --------------------------------------------------------- */


//ResizeGadget(#Gadget, x, y, Width, Height)
function ResizeGadget(Gadget, x, y, Width, Height) {

  if (x != PB_Ignore) { $("#g_" + Gadget).css({ "left": x }); }

  if (y != PB_Ignore) { $("#g_" + Gadget).css({ "top": y }); }

  if (Width != PB_Ignore) { $("#g_" + Gadget).css({ "width": Width }); }

  if (Height != PB_Ignore) { $("#g_" + Gadget).css({ "height": Height }); }

}

/* --------------------------------------------------------- */

function ScrollAreaGadget() {
  console.log('ScrollAreaGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function ScrollBarGadget() {
  console.log('ScrollBarGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// SetActiveGadget(#Gadget)
function SetActiveGadget(Gadget) {
  if ($("#g_" + Gadget) == null) { return; }
  $("#g_" + Gadget).focus();
}

/* --------------------------------------------------------- */

function ShortcutGadget() {
  console.log('ShortcutGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// Result = SpinGadget(#Gadget, x, y, Width, Height, Minimum, Maximum [, Flags])
function SpinGadget(Gadget, x, y, Width, Height, Minimum, Maximum, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  CurrentContainer.append("<input id='g_" + Gadget + "' />");

  $("#g_" + Gadget).spinner({
    min: Minimum,
    max: Maximum
  });

  $("#g_" + Gadget).spinner("widget").css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });


  // ToDo:
  // Flags to modify the gadget behavior. It can be a combination of the following values:
  // #PB_Spin_ReadOnly : The StringGadget is not editable, the number is only changeable by the arrows
  // #PB_Spin_Numeric  : The SpinGadget will automatically update the text with value of the state, so SetGadgetText() is not needed.

  $("#g_" + Gadget).data("GadgetType", PB_GadgetType_Spin);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = SplitterGadget(#Gadget, x, y, Width, Height, #Gadget1, #Gadget2 [, Flags])
function SplitterGadget(Gadget, x, y, Width, Height, Gadget1, Gadget2, Flags) {

  console.log("SplitterGadget(): Not implemented (yet)");

  /*

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  CurrentContainer.append("<div id='g_" + Gadget + "' style='width: " + Width + "px; height: " + Height + "px'></div>");

  var pstyle = 'border: 1px solid #dfdfdf; padding: 5px;';

  $("#g_" + Gadget).w2layout({
  name: 'layout',
  panels: [
  { type: 'left', size: Width / 2, resizable: true, style: pstyle, content: $("#g_" + Gadget1) },
  { type: 'main', size: Width / 2, resizable: true, style: pstyle, content: $("#g_" + Gadget2) },
  ],
  onResizing: function (target, eventData) {
  // console.log('panels of object ' + this.name + ' are being resized');
  }
  });

  $("#g_" + Gadget).css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  return Gadget;

  */

}

/* --------------------------------------------------------- */

// Result = StringGadget(#Gadget, x, y, Width, Height, Content$ [, Flags])
function StringGadget(Gadget, x, y, Width, Height, Content, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var stringGadget = $("<input />")

  stringGadget.attr("id", "g_" + Gadget);

  stringGadget.attr("value", Content);
  stringGadget.attr("type", "text");

  stringGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width });

  if (Flags) {
    if (CheckFlag(Flags, PB_String_Password)) {
      stringGadget.attr("type", "password");
    }
    else if (CheckFlag(Flags, PB_String_Numeric)) {
      stringGadget.attr("type", "number");
    }
  }

  stringGadget.data("GadgetType", PB_GadgetType_String);

  CurrentContainer.append(stringGadget);

  return Gadget;

}

/* --------------------------------------------------------- */

function StringGadget_WF(Gadget, x, y, Width, Height, Content, Flags) {
  var stringGadget = $.PureBasic.StringGadget({ gadgetid: Gadget, text: Text, x: x, y: y, width: Width, height: Height });
  return stringGadget.gadgetid;
}

/* --------------------------------------------------------- */

// Result = TextGadget(#Gadget, x, y, Width, Height, Text$ [, Flags])
function TextGadget(Gadget, x, y, Width, Height, Text, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  CurrentContainer.append("<label id='g_" + Gadget + "' style='overflow:hidden;white-space:pre-wrap;'>" + Text + "</label>");

  $("#g_" + Gadget).gadget = Gadget;

  $("#g_" + Gadget).css({ "position": "absolute", "top": y, "left": x, "width": Width });

  if (Height == -1) {
    $("#g_" + Gadget).css({ "height": "auto" });
  }
  else {
    $("#g_" + Gadget).css({ "height": Height });
  }

  // #PB_Text_Center : The text is centered in the gadget.
  // #PB_Text_Right  : The text is right aligned.
  // #PB_Text_Border : A sunken border is drawn around the gadget.

  if (Flags) {

    if (CheckFlag(Flags, PB_Text_Center)) {
      $("#g_" + Gadget).css({ "text-align": "center" });
    }

    if (CheckFlag(Flags, PBW_Text_Middle)) {
      $("#g_" + Gadget).css({ "vertical-align": "middle" });
    }

    if (CheckFlag(Flags.PB_Text_Right)) {
      $("#g_" + Gadget).css({ "text-align": "right" });
    }

    if (CheckFlag(Flags, PB_Text_Border)) {
      $("#g_" + Gadget).css({ "border": "1px solid black" });
    }

  }

  $("#g_" + Gadget).data("GadgetType", PB_GadgetType_Text);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = TrackBarGadget(#Gadget, x, y, Width, Height, Minimum, Maximum [, Flags])
function TrackBarGadget(Gadget, x, y, Width, Height, Minimum, Maximum, Flags) {

  console.log("TrackBarGadget(): Not implemented (yet)");

  /*

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  CurrentContainer.append("<div id='g_" + Gadget + "'></div>");

  // #PB_TrackBar_Ticks    : Display a 'tick' marker at each step.
  // #PB_TrackBar_Vertical : The trackbar is vertical (instead of horizontal which is the default).
  
  $("#g_" + Gadget).css({ "position": "absolute", "top": y, "left": x });

  var Orientation;

  if (CheckFlag(Flags, PB_TrackBar_Vertical)) {
  Orientation = "vertical";
  $("#g_" + Gadget).css({ "height": Height });
  }
  else {
  Orientation = "horizontal";
  $("#g_" + Gadget).css({ "width": Width });
  }

  $("#g_" + Gadget).slider({
  orientation: Orientation,
  min: Minimum,
  max: Maximum,
  value: Minimum,
  slide: function (event, ui) {
  // $( "#amount" ).val( ui.value );
  }
  });

  return Gadget;

  */

}

/* --------------------------------------------------------- */

function TreeGadget() {
  console.log('TreeGadget(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

// Result = UseGadgetList(WindowID)
function UseGadgetList(WindowID) {

  if ($("#g_" + WindowID) == null) { return; }

  var OldCurrentContainer = CurrentContainer;

  CurrentContainer = $("#g_" + WindowID);

  return OldCurrentContainer;

}

/* --------------------------------------------------------- */

// Result = WebGadget(#Gadget, x, y, Width, Height, URL$ [, Flags])
function WebGadget(Gadget, x, y, Width, Height, URL, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var webGadget = $("<iframe />");

  webGadget.attr("id", "g_" + Gadget);
  webGadget.attr("src", URL);
  webGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });
  webGadget.css({ "border": "0" });
  webGadget.css({ "frameborder": "0" });
  webGadget.data("GadgetType", PB_GadgetType_Web);

  CurrentContainer.append(webGadget);

  return Gadget;

}

/* --------------------------------------------------------- */

// Result = CreateToolBar(#ToolBar, WindowID)
function CreateToolbar(ToolBar, WindowID) {

  console.log('CreateToolbar(): Not implemented (yet)');

  /*

  if (ToolBar == -1) { ToolBar = guid(); }
  if ($("#t_" + ToolBar).length > 0) { FreeToolBar(ToolBar); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  CurrentContainer.append("<div id='t_" + ToolBar + "' style='padding: 4px; border: 1px solid silver;'></div>");

  $("#t_" + ToolBar).w2toolbar({
  name: 'toolbar',
  items: [
  { type: 'button', id: 'item1', caption: 'Item 1', img: 'icon-page', hint: 'Hint for item 1' },
  { type: 'button', id: 'item2', caption: 'Item 2', img: 'icon-page', hint: 'Hint for item 2' },
  { type: 'button', id: 'item3', caption: 'Item 3', img: 'icon-page', hint: 'Hint for item 3' },
  { type: 'button', id: 'item4', caption: 'Item 4', img: 'icon-page', hint: 'Hint for item 4' },
  { type: 'button', id: 'item5', caption: 'Item 5', img: 'icon-page', hint: 'Hint for item 5' }
  ],
  onClick: function (target, data) {
  console.log('Target: ' + target);
  console.log(data);
  }
  });

  $("#t_" + ToolBar).css({ "position": "absolute", "top": "0px", "left": "0px", "width": "100%", "height": "20px" });

  return ToolBar;

  */

}

/* --------------------------------------------------------- */

// FreeToolBar(#ToolBar)
function FreeToolBar(ToolBar) {
  console.log('FreeToolBar(): Not implemented (yet)');
}

/* --------------------------------------------------------- */

function MessageRequester(message, title) {

  $("<div></div>").dialog({
    buttons: { "OK": function () { $(this).dialog("close"); } },
    close: function (event, ui) { $(this).remove(); },
    resizable: false,
    title: title,
    modal: true
  }).text(message);
};


/* --------------------------------------------------------- */
/* --------------------------------------------------------- */

