﻿// ###############
// ### PB-Misc ###
// ###############

// Author: RSBasic
// Result = ElapsedMilliseconds()
function ElapsedMilliseconds() {
  return new Date().getTime();
}

// Author: RSBasic
// Color = RGB(Red, Green, Blue)
function RGB(Red, Green, Blue) {
  var color = Red + 256 * Green + 65536 * Blue;
  return "#" + color.toString(16);
}

// ###############
// ### PB-Math ###
// ###############

// Author: RSBasic
// Result.f = Sqr(Number.f)
function Sqr(Number) {
  return Math.sqrt(Number);
}

// Author: RSBasic
// Result.f = Abs(Number.f)
function Abs(Number) {
  return Math.abs(Number);
}

// Author: RSBasic
// Result.f = Cos(Angle.f)
function Cos(Angle) {
  return Math.cos(Angle);
}

// Author: RSBasic
// Result.f = ACos(Value.f)
function ACos(Value) {
  return Math.acos(Value);
}

// Author: RSBasic
// Result.f = ASin(Value.f)
function ASin(Value) {
  return Math.asin(Value);
}

// Author: RSBasic
// Result.f = ATan(Value.f)
function ATan(Value) {
  return Math.atan(Value);
}

// Author: RSBasic
// Result.f = Exp(Number.f)
function Exp(Number) {
  return Math.exp(Number);
}

// Author: RSBasic
// Result.f = Log(Number.f)
function Log(Number) {
  return Math.log(Number);
}

// Author: RSBasic
// Result.f = Pow(Number.f, Power.f)
function Pow(Number, Power) {
  return Math.pow(Number, Power);
}

// Author: RSBasic
// Result.f = Round(Number.f, Mode)
function Round(Number, Mode) {
  switch (Mode) {
    case PB_Round_Down:
      return Math.floor(Number);
    case PB_Round_Up:
      return Math.ceil(Number);
    case PB_Round_Nearest:
      return Math.round(Number);
  }
}

// ###############
// ### PB-HTTP ###
// ###############

// Author: RSBasic
// Result$ = URLDecoder(URL$)
function URLDecoder(URL) {
  return decodeURI(URL);
}

// Author: RSBasic
// Result$ = URLEncoder(URL$)
function URLEncoder(URL) {
  return encodeURI(URL);
}

// ###################
// ### PB-Debugger ###
// ###################

// Author: RSBasic
// Debug <Ausdruck>
function Debug(String) {
  console.log(String);
}

// Author: RSBasic
// ClearDebugOutput()
function ClearDebugOutput() {
  console.clear();
}

// ###############
// ### PB-Date ###
// ###############

// Author: RSBasic
// Result = DayOfWeek(Date)
function DayOfWeek(Date) {
  return Date.getDay();
}

// Author: RSBasic
// Result = Day(Date)
function Day(Date) {
  return Date.getDate();
}

// Author: RSBasic
// Result = Month(Date)
function Month(Date) {
  return Date.getMonth() + 1;
}

// Author: RSBasic
// Result = Year(Date)
function Year(Date) {
  return Date.getFullYear();
}

// Author: RSBasic
// Result = Hour(Date)
function Hour(Date) {
  return Date.getHours();
}

// Author: RSBasic
// Result = Minute(Date)
function Minute(Date) {
  return Date.getMinutes();
}

// Author: RSBasic
// Result = Second(Date)
function Second(Date) {
  return Date.getSeconds();
}

// Author: RSBasic
// Date = ParseDate(Mask$, String$)
function ParseDate(Mask, String) {
  return Date.parse(String, Mask);
}

// #################
// ### PB-String ###
// #################

// Author: Kiffi
// Result$ = Right(String$, Length)
function Right(String, Length) {
  return String.slice(-(Length));
}

// Author: Kiffi
// Result$ = Left(String$, Length)
function Left(String, Length) {
  return String.slice(0, Length);
}

// Author: RSBasic
// Result$ = Mid(String$, StartPosition [, Length])
function Mid(String, StartPosition, Length) {
  return typeof (Length) == "undefined" ? String.substring(StartPosition - 1) : String.substring(StartPosition - 1, StartPosition + Length - 1);
}

/*
// Author: Derren
// Result$ = Mid(String$, StartPosition [, Length])
function Mid(String, StartPosition, Length) {
if (Mid.arguments.length == 2) { Length = String.length; }
return String.substr(StartPosition - 1, Length);
}
*/

// Author: RSBasic
// Result = CountString(String$, StringToCount$)
function CountString(String, StringToCount) {
  return String.split(StringToCount).length - 1;
}

// Author: Derren
// Result$ = StringField(String$, Index, Delimiter$)
function StringField(String, Index, Delimiter) {
  return String.split(Delimiter)[Index - 1];
}

// Author: Derren
// Result$ = LCase(String$)
function LCase(String) {
  return String.toLowerCase();
}

// Author: Derren
// Result$ = UCase(String$)
function UCase(String) {
  return String.toUpperCase();
}

// Author: Derren
// Length = Len(String$)
function Len(String) {
  return String.length;
}

// Author: Derren
// Text$ = Chr(CharacterValue)
function Chr(CharacterValue) {
  return String.fromCharCode(CharacterValue);
}

// Author: Derren
// Result = Asc(String$)
function Asc(String) {
  return String.charCodeAt(0)
}

// Author: Derren
// Position = FindString(String$, StringToFind$ [, StartPosition [, Mode]])
function FindString(String, StringToFind, StartPosition, Modus) {
  if (FindString.arguments.length < 4) { Modus = PB_String_CaseSensitive; } //CaseSensitive ist Standardmodus   
  if (FindString.arguments.length == 2) { StartPosition = 0; } else { StartPosition - 1; }   //Startposition is standardmäßig 0. "-1", weil PB bei 1 anfängt und JS bei 0

  switch (Modus) {
    case PB_String_NoCase:
      String = String.toLowerCase();
      return String.substr(StartPosition, String.length).indexOf(StringToFind.toLowerCase()) + StartPosition + 1;
      break;

    default:
      return String.substr(StartPosition, String.length).indexOf(StringToFind) + StartPosition + 1;
      break;
  }
}

// Author: Derren
// Result$ = InsertString(String$, StringToInsert$, Position)
function InsertString(String, StringToInsert, Position) {
  return String.substring(0, Position - 1) + StringToInsert + String.substr(Position - 1, String.length);
}

// Author: Derren
// Result$ = LSet(String$, Length [, Character$])
function LSet(String, Length, Character) {
  if (LSet.arguments.length == 2) {
    Character = ' ';
  }
  var StringLength = String.length;
  var left = '';

  for (var k = StringLength; k < Length; k++) {
    left = left + Character;
  }

  return left + String;
}

// Author: Derren
// Result$ = RSet(String$, Length [, Character$])
function RSet(String, Length, Character) {
  if (RSet.arguments.length == 2) {
    Character = ' ';
  }
  var StringLength = String.length;
  var right = '';

  for (var k = StringLength; k < Length; k++) {
    right = right + Character;
  }

  return String + right;
}

// Author: Derren
// Result$ = ReverseString(String$)
function ReverseString(String) {
  return String.split("").reverse().join("");
}

// Author: Derren
// Result$ = Space(Length)
function Space(Length) {
  return new Array(Length + 1).join(' ')
}

// Author: RSBasic
// Result.f = ValF(String$)
function ValF(String) {
  return parseFloat(String);
}

// Author: RSBasic
// Result.q = Val(String$)
function Val(String) {
  return parseInt(String);
}

// Author: RSBasic
// Result$ = Str(Value.q)
function Str(Value) {
  return Value.toString();
}

// ###################
// ### PB-Database ###
// ###################


// UseSQLiteDatabase()
function UseSQLiteDataBase() {
  SQLiteDataBase = {};
  SQLiteDataBase.webdb = {};
  SQLiteDataBase.webdb.db = null;
}

// Result = OpenDatabase(#Database, DatabaseName$, User$, Password$ [, Plugin])
function OpenDatabase(Database, DatabaseName, user, Password) {
  var dbSize = 5 * 1024 * 1024; // 5MB
  SQLiteDataBase.webdb.db = openDatabase(DatabaseName, "1.0", DatabaseName, dbSize);
  db = SQLiteDataBase.webdb.db;
  // this one is needed, to initialize the onSucces, onError-functions
  db.transaction(function (tx) { tx.executeSql("SELECT 1", [], SQLiteDataBase.webdb.onSuccess, SQLiteDataBase.webdb.onError); });
}

// Result = DatabaseUpdate(#Database, Request$)
function DatabaseUpdate(Database, Request) {
  db.transaction(function (tx) { tx.executeSql(Request, [], SQLiteDataBase.webdb.onSuccess, SQLiteDataBase.webdb.onError); });
}

// CloseDatabase(#Database)
function CloseDatabase(Database) {
  SQLiteDataBase.webdb.db = null;
  SQLiteDataBase.webdb = null;
  db = null;
}

// Result = DatabaseQuery(#Database, Request$)
function DatabaseQuery(Database, Request) {
  SQLiteDataBase.webdb.getItems = function (renderFunc) {
    db.transaction(function (tx) { tx.executeSql(Request, [], renderFunc, SQLiteDataBase.webdb.onError); });
  }
}

// hier alle Einträge pushen
function loaddbitems(tx, rs) {
  SQLiteDataBase.result = null;
  SQLiteDataBase.result = new Array();
  // wie kann ich ein mehrdimensionales Array mit Daten füllen?
  // hier soll das DB-Ergebnis in SQLiteDataBase.result übernommen werden, um mit den üblichen PureBasic-Befehlen darauf zuzugreifen...
  for (var i = 0; i < rs.rows.length; i++) {
    for (var key in rs.rows.item(i)) { alert(key); SQLiteDataBase.result.push(key); }
  }
  //     alert(SQLiteDataBase.result.join('\n'))  
}

