﻿function PBW_HyperLinkGadget(Gadget, x, y, Width, Height, Text, Url, Target) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  if (Target == null) {
    Target = "_blank";
  }

  CurrentContainer.append("<a id='g_" + Gadget + "' href='" + Url + "' target='" + Target + "'>" + Text + "</a>");

  $("#g_" + Gadget).data("Gadget", Gadget);
  $("#g_" + Gadget).css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  return Gadget;

};

function PBW_SetGadgetCursor(Gadget, Cursor) {
  $("#g_" + Gadget).css('cursor', Cursor);
};

function PBW_SetWindowOption(Window, Optionname, OptionValue) {
  $("#w_" + Window).dialog("option", Optionname, OptionValue);
};

function PBW_SetEventHandler(ID, ObjectType, Function, Event) {

  switch (ObjectType) {
    case PBW_Window:
      $("#w_" + ID).on(Event, function (event, ui) { Function(ID, event, ui); });
      break;
    case PBW_Gadget:
      $("#g_" + ID).on(Event, function (event) { Function(ID); });
      break;
    case PBW_Menu:
      $("#m_" + ID).on(Event, function (event) { Function(ID); });
      break;
    case PBW_SysTray:
      break;
    case PBW_Timer:
      $("#t_" + ID).on(Event, function (event) { Function(ID); });
      break;
    case PBW_Special:
      break;
    default:
      break;
  }

};

function PBW_ListIconGadget(Gadget, x, y, Width, Height, Title, TitleWidth, Flags) {

  if (Gadget == -1) { Gadget = guid(); }
  if ($("#g_" + Gadget).length > 0) { FreeGadget(Gadget); }
  if (CurrentContainer == null) { CurrentContainer = $('body'); }

  var listIconGadget = $("<div />");

  listIconGadget.attr("id", "g_" + Gadget);

  listIconGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });

  listIconGadget.w2grid({
    name: "g_" + Gadget,
    columns: [{ field: guid(), caption: Title, size: TitleWidth}]
  });

  listIconGadget.data("GadgetType", PBW_GadgetType_ListIcon);

  CurrentContainer.append(listIconGadget);

  return Gadget;

};

function PBW_ServerRequest(Type, Data, Url, onSuccess, onError) {

  $.ajax({

    type: Type,
    data: Data,
    url: Url,

    success: function () {
      onSuccess();
    },

    error: function () {
      onError();
    }


  });

};
