﻿// Result = OpenWindow(#Window, x, y, InnerWidth, InnerHeight, Title$ [, Flags [, ParentWindowID]])
function OpenWindow(Window, x, y, InnerWidth, InnerHeight, Title, Flags, ParentWindowID) {

  InnerWidth += 5;
  InnerHeight += 40;

  if (Window === -1) {
    Window = guid();
  }

  if ($("#w_" + Window).length > 0) {

    $("#w_" + Window).dialog("moveToTop");
    return;

    // CloseWindow(Window);

  };

  if (CurrentContainer == null) {
    CurrentContainer = $('body');
  }

  CurrentContainer.append("<div id='w_" + Window + "'></div>");

  CurrentContainer = $("#w_" + Window);

  //dialog options
  var dialogOptions = {
    "title": Title,
    "width": InnerWidth,
    "height": InnerHeight,
    "close": function (event) { CloseWindow(Window); }
  };

  if ((Flags & PB_Window_SizeGadget) == PB_Window_SizeGadget) {
    dialogOptions.resizable = true;
  }
  else {
    dialogOptions.resizable = false;
  }

  if ((Flags & PB_Window_ScreenCentered) == PB_Window_ScreenCentered) {
    //
  }
  else {
    dialogOptions.position = [x, y];
  }

  if (ParentWindowID != null) {
    dialogOptions.modal = true;
  }

  $("#w_" + Window).dialog(dialogOptions);

  return Window;

}

// CloseWindow(#Window)
function CloseWindow(Window) {

  var selector = $("#w_" + Window);

  if (selector == null) {
    console.log('selector #w_' + Window + ': null');
    return;
  }

  selector.empty();
  selector.remove();

  CurrentContainer = null;

}

// Result = WindowWidth(#Window [, Mode]) 
function WindowWidth(Window, Mode) {

  var selector = $("#w_" + Window);

  if (selector == null) {
    console.log('selector #w_' + Window + ': null');
    return 0;
  }

  var width = selector.dialog("option", "width");
  return width;
}

// Result = WindowHeight(#Window [, Mode]) 
function WindowHeight(Window, Mode) {

  var selector = $("#w_" + Window);

  if (selector == null) {
    console.log('selector #w_' + Window + ': null');
    return 0;
  }

  var height = selector.dialog("option", "height");
  return height - 36;

}

// AddWindowTimer(#Window, Timer, Timeout)
function AddWindowTimer(Window, Timer, Timeout, CallbackFunction) {

  if ($("#w_" + Window) == null) {
    console.log('selector #w_' + Window + ': null');
    return;
  }

  if ($("#t_" + Timer + "_w_" + Window).length > 0) { RemoveWindowTimer(Window, Timer); }

  $("#w_" + Window).append("<div id='t_" + Timer + "_w_" + Window + "'></div>");

  $("#t_" + Timer + "_w_" + Window).timer({
    delay: Timeout,
    repeat: true,
    callback: function (index) {
      CallbackFunction();
    }
  });

}

// RemoveWindowTimer(#Window, Timer)
function RemoveWindowTimer(Window, Timer) {

  if ($("#w_" + Window) == null) {
    console.log('selector #w_' + Window + ': null');
    return;
  }

  if ($("#t_" + Timer + "_w_" + Window) == null) {
    console.log('selector #t_' + Timer + ': null');
    return;
  }

  $("#t_" + Timer + "_w_" + Window).timer("stop");
  $("#t_" + Timer + "_w_" + Window).empty();
  $("#t_" + Timer + "_w_" + Window).remove();

}

// ResizeWindow(#Window, x, y, Width, Height) 
function ResizeWindow(Window, x, y, Width, Height) {

  var selector = $("#w_" + Window);

  if (selector == null) {
    console.log('selector #w_' + Window + ': null');
    return;
  }

  var pos = selector.dialog("option", "position");

  if (x == PB_Ignore) { x = pos[0]; }
  if (y == PB_Ignore) { y = pos[1]; }

  selector.dialog("option", "position", [x, y]);

  if (Width != PB_Ignore) { selector.dialog("option", "width", Width); };
  if (Height != PB_Ignore) { selector.dialog("option", "height", Height); };

}